diff --git a/doc/src/sgml/architecture.sgml b/doc/src/sgml/architecture.sgml
new file mode 100644
index 0000000000..014a1172b6
--- /dev/null
+++ b/doc/src/sgml/architecture.sgml
@@ -0,0 +1,1159 @@
+<!-- doc/src/sgml/architecture.sgml -->
+
+ <chapter id="tutorial-architecture">
+  <title>Architecture of <productname>PostgreSQL</productname></title>
+
+  <para>
+   Every DBMS implements basic strategies to achieve a fast and
+   robust system. This chapter provides an overview of what
+   techniques <productname>PostgreSQL</productname> uses to
+   reach this aim.
+  </para>
+
+  <sect1 id="tutorial-ram-proc-file">
+   <title>Collaboration of Processes, RAM, and Files</title>
+   <para>
+    As is a matter of course, in a client/server architecture
+    clients do not have direct access to the database. Instead,
+    they merely send requests to the server side and receives
+    according information from there. In the case of
+    <productname>PostgreSQL</productname>, at the server
+    side there is one process per client, the so-called
+    <glossterm linkend="glossary-backend">Backend process</glossterm>.
+    It acts in close cooperation with the
+    <glossterm linkend="glossary-instance">Instance</glossterm> which
+    is a group of tightly coupled other server side processes plus a
+    <glossterm linkend="glossary-shared-memory">Shared Memory</glossterm>
+    area.
+   </para>
+
+   <para>
+    At start time, an instance is initiated by the
+    <glossterm linkend="glossary-postgres">Postgres</glossterm>
+    (or: Postmaster) process.
+    It loads the configuration files, allocates the
+    <glossterm linkend="glossary-shared-memory">Shared Memory</glossterm>
+    and starts the comprehensive network of processes:
+    <glossterm linkend="glossary-background-writer">Background Writer</glossterm>,
+    <glossterm linkend="glossary-checkpointer">Checkpointer</glossterm>,
+    <glossterm linkend="glossary-wal-writer">WAL Writer</glossterm>,
+    <glossterm linkend="glossary-wal-archiver">WAL Archiver</glossterm>,
+    <glossterm linkend="glossary-autovacuum">Autovacuum processes</glossterm>,
+    <glossterm linkend="glossary-stats-collector">Statistics Collector</glossterm>,
+    <glossterm linkend="glossary-logger">Logger</glossterm>, and more.
+    <xref linkend="tutorial-ram-proc-file-figure"/> visualizes
+    main aspects of their collaboration.
+   </para>
+
+   <figure id="tutorial-ram-proc-file-figure">
+    <title>Architecture</title>
+    <mediaobject>
+     <imageobject role="html">
+      <!-- attribute 'width=..px' is necessary to keep font-size of SVG text
+           in correlation with font-size of surrounding HTML  -->
+      <imagedata fileref="images/ram-proc-file-raw.svg" format="SVG" width="900px" />
+     </imageobject>
+     <imageobject role="fo">
+      <!-- For PDF attribute 'width=100%' is necessary to keep complete SVG visible
+           on the page, which has a fixed width. Font sizes will be adopted.  -->
+      <imagedata fileref="images/ram-proc-file-raw.svg" format="SVG" width="100%" />
+     </imageobject>
+    </mediaobject>
+   </figure>
+
+   <para>
+    Whenever a client application tries to connect to a
+    <glossterm linkend="glossary-database">database</glossterm>,
+    this request is handled in a first step by the <firstterm>
+    Postgres process</firstterm>. It checks the authorization,
+    starts a new <firstterm>Backend process</firstterm>,
+    and instructs the client application to connect to it. All
+    further client requests go to this process and are handled
+    by it.
+   </para>
+
+   <para>
+    Client requests (SELECT, UPDATE, ...) usually leads to the
+    necessity to read or write some data. In a first attempt
+    the client's <firstterm>Backend process</firstterm> tries
+    to get the information out of <firstterm>Shared
+    Memory</firstterm>. This <firstterm>Shared
+    Memory</firstterm> is a mirror of parts of the
+    <glossterm linkend="glossary-heap">heap</glossterm> and
+    <glossterm linkend="glossary-index">index</glossterm> files.
+    Because files are much larger than memory, it's likely that
+    the desired information is not (completely) available
+    in the RAM. In this case the <firstterm>Backend process
+    </firstterm> must transfer additional file pages to
+    <firstterm>Shared Memory</firstterm>. Files are physically
+    organized in pages. Every transfer between files and
+    RAM is performed in units of complete pages, retaining
+    their size and layout.
+   </para>
+
+   <para>
+    Reading file pages is notedly slower than reading
+    RAM. This is the main motivation for the existence of
+    <firstterm>Shared Memory</firstterm>. As soon as one
+    of the <firstterm>Backend processes</firstterm> has done
+    the job those pages are available for all other
+    <firstterm>Backend processes</firstterm> for direct
+    access in RAM.
+   </para>
+
+   <para>
+    <firstterm>Shared Memory</firstterm> is limited in size.
+    Sooner or later it becomes necessary to overwrite old RAM
+    pages. As long as the content of such pages hasn't
+    changed this is not a problem. But in
+    <firstterm>Shared Memory</firstterm> also write
+    actions take place
+    - performed by any of the <firstterm>Backend
+    processes</firstterm> (or an
+    <glossterm linkend="glossary-autovacuum">autovacuum process</glossterm>,
+    or other processes). Such modified pages are called
+    <firstterm>dirty pages</firstterm>.
+    Before <firstterm>dirty pages</firstterm> can be overwritten,
+    they must be transferred back to disk. This is a two-step process.
+   </para>
+
+   <para>
+    First, whenever the content of a page changes, a
+    <glossterm linkend="glossary-wal-record">WAL record</glossterm>
+    is created out
+    of the delta-information (difference between old and
+    new content) and stored in another area of the
+    <firstterm>Shared Memory</firstterm>. These
+    <firstterm>WAL records</firstterm> are read by the
+    <firstterm>WAL Writer</firstterm> process,
+    which runs in parallel to the <firstterm>Backend
+    processes</firstterm> and all other processes of
+    the <firstterm>Instance</firstterm>. It writes
+    the continuously arising <firstterm>WAL records</firstterm> to
+    the end of the current
+    <glossterm linkend="glossary-wal-record">WAL file</glossterm>.
+    Because of the sequential nature of this writing, it is much
+    faster than the more or less random access
+    to data files with <firstterm>heap</firstterm>
+    and <firstterm>index</firstterm> information.
+    As mentioned, this WAL-writing happens
+    in an independent process. Nevertheless all
+    <firstterm>WAL records</firstterm> created out of one
+    <firstterm>dirty page</firstterm> must be transferred
+    to disk before the <firstterm>dirty page</firstterm>
+    itself can be transferred to disk.
+   </para>
+
+   <para>
+    Second, the transfer of <firstterm>dirty buffers</firstterm>
+    from <firstterm>Shared Memory</firstterm> to files must
+    take place. This is the primary duty of the
+    <firstterm>Background Writer</firstterm> process. Because
+    huge I/O activities can block other processes significantly,
+    it starts periodically and acts only for a short period.
+    Doing so, his expensive I/O activities are spread over
+    time avoiding huge I/O peaks. Also the <firstterm>
+    Checkpointer</firstterm> process transfers
+    <firstterm>dirty buffers</firstterm> to files, see next
+    paragraph.
+   </para>
+
+   <para>
+    The <firstterm>Checkpointer</firstterm> has a special
+    duty. As its name suggests, he has to create
+    <firstterm>Checkpoints</firstterm>. Such a
+    <glossterm linkend="glossary-checkpoint">Checkpoint</glossterm>
+    is a point in time when all older <firstterm>dirty buffers</firstterm>,
+    all older <firstterm>WAL records</firstterm>, and
+    lastly a special <firstterm>Checkpoint record
+    </firstterm> have been written and flushed to disk.
+    In consequence, after a <firstterm>Checkpoint</firstterm>
+    data files and <firstterm>WAL files</firstterm> are in sync.
+    In case of a recovery (after a crash of the instance)
+    it is known that the information of all
+    <firstterm>WAL records</firstterm> preceding
+    the last <firstterm>Checkpoint record</firstterm>
+    is already integrated into the data files. This
+    speeds up a possibly occurring recovery.
+   </para>
+
+   <para>
+    In correlation with data changes,
+    <firstterm>WAL records</firstterm> arise and are written
+    to <firstterm>WAL files</firstterm>.
+    Those <firstterm>WAL files</firstterm> - in combination with
+    a previously taken <firstterm>Base Backup</firstterm> -
+    are necessary to restore a database after a crash of the
+    disk, where data files have been stored. Therefore it is
+    recommended to transfer a copy of the <firstterm>
+    WAL files</firstterm>
+    to a second, independent place. The purpose of the
+    <firstterm>WAL Archiver</firstterm> process is to perform
+    this copy action.
+   </para>
+
+   <para>
+    The <glossterm linkend="glossary-stats-collector">Stats Collector</glossterm>
+    collects counters about accesses to <firstterm>SQL
+    objects</firstterm> like tables, rows, indexes, pages,
+    and more. It stores the obtained information in system
+    tables.
+   </para>
+
+   <para>
+    The <glossterm linkend="glossary-logger">Logger</glossterm> writes
+    text lines about serious and non-serious events which can happen
+    during database access, e.g.: wrong password, no permission,
+    long-running queries, ... .
+   </para>
+
+  </sect1>
+
+  <sect1 id="tutorial-cluster-db-schema">
+   <title>The logical Perspective: Cluster, Database, Schema</title>
+
+   <para>
+    On a <glossterm linkend="glossary-server">Server</glossterm>
+    exists one or more <glossterm linkend="glossary-cluster">Cluster</glossterm>,
+    each of them contains three or more
+    <glossterm linkend="glossary-database">databases</glossterm>, each
+    database contains many <glossterm linkend="glossary-schema">schema</glossterm>,
+    a schema contains <glossterm linkend="glossary-table">tables</glossterm>,
+    <glossterm linkend="glossary-view">views</glossterm>, and a lot of other objects.
+    Each <firstterm>table</firstterm> or <firstterm>view</firstterm>
+    belongs to a certain <firstterm>schema</firstterm>, they cannot
+    belong to another <firstterm>schema</firstterm>. The same is
+    true for the schema/database and database/cluster relation.
+    <xref linkend="tutorial-cluster-db-schema-figure"/> visualizes
+    this hierarchy.
+   </para>
+
+   <figure id="tutorial-cluster-db-schema-figure">
+    <title>Cluster, Database, Schema</title>
+    <mediaobject>
+     <imageobject role="html">
+      <!-- attribute 'width=..px' is necessary to keep font-size of SVG text
+           in correlation with font-size of surrounding HTML  -->
+      <imagedata fileref="images/cluster-db-schema-raw.svg" format="SVG" width="900px" />
+     </imageobject>
+     <imageobject role="fo">
+      <!-- For PDF attribute 'width=100%' is necessary to keep complete SVG visible
+           on the page, which has a fixed width. Font sizes will be adopted.  -->
+      <imagedata fileref="images/cluster-db-schema-raw.svg" format="SVG" width="100%" />
+     </imageobject>
+    </mediaobject>
+   </figure>
+
+   <para>
+    A <firstterm>Cluster</firstterm> is the outer frame for a
+    collection of databases. Clusters are created by the command
+    <xref linkend="app-initdb"/>.
+   </para>
+
+   <para>
+    <literal>template0</literal> is the very first
+    <firstterm>database</firstterm> of any
+    <firstterm>cluster</firstterm>. C-routines create
+    <literal>template0</literal> during the initialization phase of
+    the <firstterm>cluster</firstterm>.
+    In a second step <literal>template1</literal> is generated
+    as a copy of <literal>template0</literal> and finally
+    <literal>postgres</literal> as a copy of
+    <literal>template1</literal>. All other
+    <glossterm linkend="app-createdb">new databases</glossterm>
+    of this <firstterm>cluster</firstterm>,
+    such as <literal>my_db</literal>, are also copied from
+    <literal>template1</literal>. Due to the special
+    role of <literal>template0</literal> as the origin
+    of all other <firstterm>databases</firstterm>, no client
+    can connect to it.
+   </para>
+
+   <para>
+    Every database contains <glossterm linkend="glossary-schema">
+    schemas</glossterm>, and
+    <firstterm>schemas</firstterm> contain the other
+    <glossterm linkend="glossary-sql-object">SQL Objects</glossterm>.
+    <firstterm>Schemas</firstterm> are namespaces for
+    their <firstterm>SQL objects</firstterm> and ensure - with one
+    exception - that within their scope names are used only once across all
+    types of <firstterm>SQL objects</firstterm>. E.g., it is not possible
+    to have a table <literal>employee</literal> and a view
+    <literal>employee</literal> within the same
+    <firstterm>schema</firstterm>. But it is possible to have
+    two tables <literal>employee</literal> in different
+    <firstterm>schemas</firstterm>. In this case the two tables
+    are different objects and absolutely independent from each
+    other. The only exception to this cross-type uniqueness is that
+    <glossterm linkend="glossary-unique-constraint">unique constraints
+    </glossterm> and the according <firstterm>unique index</firstterm>
+    use the same name.
+   </para>
+
+   <para>
+    Some <firstterm>schemas</firstterm> are predefined.
+    <literal>public</literal> acts as the default
+    <firstterm>schema</firstterm> and contains all such
+    <firstterm>SQL objects</firstterm>, which are created
+    within <literal>public</literal> or without using any schema
+    name. <literal>public</literal> shall not contain user defined
+    <firstterm>SQL objects</firstterm>. Instead, it is recommended to
+    create a separate <firstterm>schema</firstterm> which
+    holds individual objects like application-specific tables or
+    views. <literal>pg_catalog</literal> is a schema for all tables
+    and views of the <glossterm linkend="glossary-system-catalog">
+    System Catalog</glossterm>.
+    <literal>information_schema</literal> is a schema for several
+    tables and views of the <firstterm>System Catalog</firstterm>
+    in a way which conforms to the SQL standard.
+   </para>
+
+   <para>
+    There are a lot of different <firstterm>SQL object</firstterm>
+    types: <firstterm>database, schema, table, view, materialized
+    view, index, constraint, sequence, function, procedure,
+    trigger, role, data type, operator, tablespace, extension,
+    foreign data wrapper</firstterm>, and more. A few of them, the
+    <glossterm linkend="glossary-global-sql-object">Global SQL Objects</glossterm>,
+    are outside of the strict hierarchy:
+    All database names, all tablespace names, and all role names
+    are automatically known and available throughout the
+    complete <firstterm>cluster</firstterm>, independent from
+    the database or schema in which they where originally
+    defined. <xref linkend="tutorial-internal-objects-hierarchy-figure"/>
+    shows the relation between the object types.
+   </para>
+
+   <figure id="tutorial-internal-objects-hierarchy-figure">
+    <title>Hierarchy of Internal Objects</title>
+    <mediaobject>
+     <imageobject role="html">
+      <!-- attribute 'width=..px' is necessary to keep font-size of SVG text
+           in correlation with font-size of surrounding HTML  -->
+      <imagedata fileref="images/internal-objects-hierarchy-raw.svg" format="SVG" width="720px" />
+     </imageobject>
+     <imageobject role="fo">
+      <!-- For PDF attribute 'width=100%' is necessary to keep complete SVG visible
+           on the page, which has a fixed width. Font sizes will be adopted.  -->
+      <imagedata fileref="images/internal-objects-hierarchy-raw.svg" format="SVG" width="100%" />
+     </imageobject>
+    </mediaobject>
+   </figure>
+
+  </sect1>
+
+  <sect1 id="tutorial-directories">
+   <title>The physical Perspective: Directories and Files</title>
+
+   <para>
+    <productname>PostgreSQL</productname> organizes long lasting
+    data as well as volatile state information about transactions
+    or replication actions in the file system. Every
+    <firstterm>Cluster</firstterm> has its own root directory
+    anywhere in the file system. In many cases, the environment
+    variable <literal>PGDATA</literal> points to this directory.
+    The example of the following survey, which is shown in
+    <xref linkend="tutorial-directories-figure"/>, uses
+    <literal>data</literal> as the name of this root directory.
+   </para>
+
+   <figure id="tutorial-directories-figure">
+    <title>Directory Structure</title>
+    <mediaobject>
+     <imageobject role="html">
+      <!-- attribute 'width=..px' is necessary to keep font-size of SVG text
+           in correlation with font-size of surrounding HTML  -->
+      <imagedata fileref="images/directories-raw.svg" format="SVG" width="900px" />
+     </imageobject>
+     <imageobject role="fo">
+      <!-- For PDF attribute 'width=100%' is necessary to keep complete SVG visible
+           on the page, which has a fixed width. Font sizes will be adopted.  -->
+      <imagedata fileref="images/directories-raw.svg" format="SVG" width="100%" />
+     </imageobject>
+    </mediaobject>
+   </figure>
+
+   <para>
+    <literal>data</literal> contains many subdirectories and
+    some files, all of which are necessary to store long lasting
+    as well as temporary data. The following paragraphs
+    describe the files and subdirectories in
+    <literal>data</literal>.
+   </para>
+
+   <para>
+    <literal>base</literal> is a subdirectory in which one
+    subdirectory per <firstterm>database</firstterm> exists.
+    The names of those subdirectories consist of numbers.
+    These are the internal
+    <firstterm>Object Identifiers (OID)</firstterm>, which are
+    numbers to identify the database definition in the
+    <glossterm linkend="glossary-system-catalog">System Catalog</glossterm>.
+   </para>
+
+   <para>
+    Within the <firstterm>database</firstterm>-specific
+    subdirectories there are many files: one or more for
+    every table and every index to store <firstterm>heap</firstterm>
+    and <firstterm>index</firstterm> data. Those files are
+    accompanied by files for the
+    <link linkend="storage-fsm">Free Space Maps</link>
+    (extension <literal>_fsm</literal>) and
+    <link linkend="storage-vm">Visibility Maps</link>
+    (extension <literal>_vm</literal>), which contain optimization information.
+   </para>
+
+   <para>
+    Another important subdirectory is <literal>global</literal>.
+    In analogy to the <firstterm>database</firstterm>-specific
+    subdirectories, there are files containing information about
+    <glossterm linkend="glossary-global-sql-object">Global SQL objects</glossterm>.
+    One type of such <firstterm>Global Objects</firstterm> are
+    <firstterm>tablespaces</firstterm>. In
+    <literal>global</literal> there is information about
+    the <firstterm>tablespaces</firstterm>, not the
+    <firstterm>tablespaces</firstterm> itself.
+   </para>
+
+   <para>
+    The subdirectory <literal>pg_wal</literal> contains the
+    <glossterm linkend="glossary-wal-file">WAL files</glossterm>.
+    They arise and grow parallel to data changes in the
+    <firstterm>cluster</firstterm> and remain alive as long as
+    they are required for recovery, archiving, or replication.
+   </para>
+
+   <para>
+    The subdirectory <literal>pg_xact</literal> contains
+    information about the status of each transaction
+    (IN_PROGRESS, COMMITTED, ABORTED, or SUB_COMMITTED).
+   </para>
+
+   <para>
+    In <literal>pg_tblspc</literal> there are symbolic links
+    that point to directories containing such<firstterm>
+    SQL objects</firstterm> that are created within
+    <firstterm>tablespaces</firstterm>.
+   </para>
+
+   <para>
+    In the root directory <literal>data</literal>
+    there are also some files.
+    In many cases, the configuration
+    files of this <firstterm>cluster</firstterm>
+    are stored here. As long as the <firstterm>
+    cluster</firstterm> is up and running, the file
+    <literal>postmaster.pid</literal> exists here
+    and contains the ID (pid) of the
+    <firstterm>Postgres</firstterm> (respectively
+    <firstterm>Postmaster</firstterm>) process.
+   </para>
+
+   <para>
+    For more details about the physical implementation
+    of database objects, see <xref linkend="storage"/>.
+   </para>
+
+  </sect1>
+
+  <sect1 id="tutorial-mvcc">
+   <title>MVCC</title>
+
+   <para>
+    In most cases, <productname>PostgreSQL</productname> based applications
+    support many clients at the same time. Therefore, it is necessary to
+    protect simultaneously running requests from unwanted overwriting
+    of other's data as well as from reading inconsistent data. Imagine an
+    online shop offering the last copy of an article. Two clients show the
+    article at their user interface. After a while, but at the same time,
+    both users decide to put it to their shopping cart or even to buy it.
+    The dabase must take a sensible decision to prevent the application
+    from promising delivery of the single article to both clients.
+   </para>
+
+   <para>
+    A first approach may be the locking of critical rows. There are
+    two main categories of such techniques: <emphasis>Optimistic Concurrency
+    Control</emphasis> (OCC) and <emphasis>Two Phase Locking</emphasis> (2PL).
+    <productname>PostgreSQL</productname> implements the more sophisticated
+    technique <firstterm>Multiversion Concurrency Control</firstterm> (MVCC).
+    The crucial advantage of MVCC over other technologies gets evident
+    in multiuser OLTP environments with a huge number of concurrent write
+    actions. There, MVCC generally performs better than solutions using locks.
+    In a <productname>PostgreSQL</productname> database reading never blocks
+    writing and writing never blocks reading, even in the strictest level of
+    transaction isolation.
+   </para>
+
+   <para>
+    Instead of locking rows, the <firstterm>MVCC</firstterm> technique creates
+    a new version of the same row when any data-change takes place. In order
+    to distinct between these versions as well as to track the timeline
+    of the row, each of the versions contain, in additon to their user
+    defined columns, two special system columns, which are not visible
+    for the usual <command>SELECT * FROM ...</command> command.
+    The column <command>xmin</command> contains the transaction ID (xid)
+    of the transaction which creates this version of the row. Accordingly,
+    <command>xmax</command> contains the xid of the transaction which has
+    deleted this version respectively a zero, if the version is not
+    deleted. You can read both with the command
+    <command>SELECT xmin, xmax, * FROM ... </command>.
+   </para>
+
+   <para>
+    When we speak about transaction IDs, you need to know that xids are like
+    sequences. Every new transaction receives the next number as its ID.
+    Therefore, this flow of xids represents the flow of transaction
+    start events over time. But keep in mind that xids are independent from
+    any real time messurement - in milliseconds or whatever. If you dive
+    deeper into <productname>PostgreSQL</productname>, you will recognize
+    parameters with names such as 'xxx_age'. Despite of their names,
+    these '_age' parameters do not specify a period of time but represent
+    a certain number of transactions, e.g. 100 millions.
+   </para>
+
+   <para>
+    Please note that the description in this chapter simplifies the facts
+    by omitting details. When many transactions are running simultaneously,
+    things can get very complicated. Sometimes they get aborted via
+    ROLLBACK immediately or after a lot of other activities, sometimes
+    a single row is involved in more than one transaction, sometimes
+    a client crashes, sometimes the sequence of xids restarts
+    from zero, ... . Therefore, every version of a row contains more
+    system columns and flags, not only xmin and xmax.
+   </para>
+
+   <para>
+    So, what's going on in detail when write accesses take place?
+    <xref linkend="tutorial-mvcc-figure"/> shows details concerning
+    xmin, xmax, and the user data.
+   </para>
+
+   <figure id="tutorial-mvcc-figure">
+    <title>Multiversion Concurrency Control</title>
+    <mediaobject>
+     <imageobject role="html">
+      <imagedata fileref="images/mvcc-raw.svg" format="SVG" width="900px" />
+     </imageobject>
+     <imageobject role="fo">
+      <!-- For PDF attribute 'width=100%' is necessary to keep complete SVG visible
+           on the page, which has a fixed width. Font sizes will be adopted.  -->
+      <imagedata fileref="images/mvcc-raw.svg" format="SVG" width="100%" />
+     </imageobject>
+    </mediaobject>
+   </figure>
+
+   <para>
+    An <command>INSERT</command> command creates the first
+    version of a row. Beside its user data <literal>'x'</literal>,
+    this version contains the ID of the creating transaction <literal>123</literal>
+    in xmin and <literal>0</literal> in xmax. xmin indicates that the version
+    exists since transaction <literal>123</literal> and xmax indicates that
+    it is currently not deleted.
+   </para>
+
+   <para>
+    Somewhat later, transaction <literal>135</literal> executes an
+    <command>UPDATE</command> of this row, intending to change the user data
+    from <literal>'x'</literal> to <literal>'y'</literal>. According to
+    the MVCC principles, the data in the old version of the row does not
+    change! The value <literal>'x'</literal> keeps as it was before.
+    Only xmax changes to <literal>135</literal>. Now this version
+    is treated as valid exclusively for transactions with xids from
+    <literal>123</literal> to <literal>134</literal>. As a substitute
+    for the non-ocurring change of data in the old version, the
+    <command>UPDATE</command> creates a new version of the row with
+    its xid in xmin, 0 in xmax, and <literal>'y'</literal> in the
+    user data (plus all the other user data from the old version).
+    This version is now valid for all comming transactions.
+   </para>
+
+   <para>
+    All subsequent <command>UPDATE</command> commands behave in the
+    same way as the first one: they put their
+    xid to xmax of the current version, create the next version
+    with their xid in xmin, 0 in xmax, and the new user data.
+   </para>
+
+   <para>
+    Finally, a row may be deleted by a <command>DELETE</command>.
+    Even in this case all versions of the row keep as
+    before, nothing is thrown away! Only xmax of the last
+    version changes to the xid of the  <command>DELETE</command>
+    transaction, which indicates that it is only valid for
+    transactions with xids older than its own (from
+    <literal>142</literal> to <literal>820</literal> in this
+    example).
+   </para>
+
+   <para>
+    In summary, the MVCC technology creates more and more versions
+    of the same row in a table's heap file and leaves them there,
+    even with a DELETE command. The youngest version is relevant
+    for all future transactions. But the system must also preserve
+    some of the older ones for a certain amount of time as there
+    is the possiblility that they are or could become relevant
+    for any of the pending transactions. Over time, also the
+    older ones get out of scope for ALL transactions and therefore
+    becomes unnecessary. Nevertheless, they exist physically on
+    the disk and occupy space.
+   </para>
+
+   <para>
+    Please keep in mind:
+   </para>
+   <itemizedlist spacing="compact" mark="opencircle">
+
+    <listitem>
+     <simpara>
+      xmin and xmax indicate the range from where to where
+      row versions are valid (visible) for transactions.
+      This range doesn't imply any direct temporal meaning,
+      the sequence of xids reflects only the sequence of
+      transaction begin events. As
+      xids grow, old row versions get out of scope over time.
+      If an old row version is no longer valid for ALL existing
+      transactions, it's called <firstterm>dead</firstterm>. The
+      space occupied by the sum of all dead row versions is
+      called <firstterm>bloat</firstterm>.
+     </simpara>
+    </listitem>
+
+    <listitem>
+     <simpara>
+      Internally, an <command>UPDATE</command> command acts in the
+      same way as a <command>DELETE</command> command followed by
+      an <command>INSERT</command> command.
+     </simpara>
+    </listitem>
+
+    <listitem>
+     <simpara>
+      Nothing gets wiped away - with the consequence that the database
+      occupies more and more disc space. It is obvious that
+      this behaviour has to be automatically corrected in some
+      way. The next chapter explains how AUTOVACUUM fulfills
+      this task.
+     </simpara>
+    </listitem>
+
+   </itemizedlist>
+
+  </sect1>
+
+  <sect1 id="tutorial-vacuum">
+   <title>Vacuum</title>
+
+   <para>
+    As we have seen in the previous chapter, the database tends to occupy
+    more and more disc space, the <firstterm>bloat</firstterm>.
+    This chapter explains how the SQL command
+    <firstterm>VACUUM</firstterm> and the automatically running
+    <firstterm>AUTOVACUUM</firstterm> processes clear the situation.
+   </para>
+
+   <para>
+    Client processes can issue the SQL command VACUUM at arbitrary
+    points in time. DBAs do this when they recognize special situations
+    or they start it in batch jobs which run on a regular basis.
+    AUTOVACUUM processes run as part of the
+    <link linkend="glossary-instance">Instance</link> at the server.
+    There is an constantly running AUTOVACUUM daemon. He permantly
+    controlls the state of all databases based on values which are
+    collected by the <link linkend="glossary-stats-collector">
+    Statistics Collector</link> and starts
+    AUTOVACUUM processes whenever he detects certain situations.
+    Thus, it's a dynamic behavior of <productname>PostgreSQL</productname>
+    with the intention to tidy up - not always, but whenever it
+    is appropriate.
+   </para>
+
+   <para>
+    VACUUM as well as AUTOVACUUM don't just eliminate bloat.
+    They perform additional tasks to minimizing future
+    I/O activities of themselves as well as of other processes.
+    This additional work can be done in a very efficient way,
+    since in most cases the expensive physical access to pages
+    has taken place anyway for the purpose of eliminating bloat.
+    The additional operations are:
+   </para>
+
+   <itemizedlist spacing="compact" mark="opencircle">
+
+    <listitem>
+     <simpara>
+      <firstterm>Freeze</firstterm>: Mark the jungest row version
+      as frozen. This means that the version
+      is always treated as valid (visible) independent from
+      the <firstterm>wraparound problematic</firstterm> (see below).
+     </simpara>
+    </listitem>
+
+    <listitem>
+     <simpara>
+      <firstterm>Visibility Map</firstterm> and
+      <firstterm>Free Space Map</firstterm>: Log information about
+      the state of the handled pages in two additional files, the
+      Visibility Map and the Free Space Map.
+     </simpara>
+    </listitem>
+
+    <listitem>
+     <simpara>
+      <emphasis>Statistics</emphasis>: Collect statistics about the
+      number of rows per table, the distribution of values, and so on,
+      as the basis for query planners decision making.
+     </simpara>
+    </listitem>
+
+   </itemizedlist>
+
+   <para>
+    The eagerness - you can call it 'agressivity' - of the
+    operations <emphasis>eliminating bloat</emphasis> and
+    <emphasis>freeze</emphasis> is controlled by configuration
+    parameters, runtime flags and in extreme situations by
+    themselves. Because vacuum operations typically are I/O
+    intensive, which can hinder other activities, AUTOVACUUM
+    avoids to perform many vacuum operations in a bulk. Instead,
+    it carries out many short actions with time gaps in between.
+    The SQL command VACUUM runs immediately without any
+    time gaps.
+   </para>
+
+   <sect2>
+    <title>Eliminate Bloat</title>
+
+    <para>
+     To determine which of the row versions are superfluous, the
+     elimination operation must evaluate xmax against several criterias
+     which all must apply:
+    </para>
+    <itemizedlist spacing="compact" mark="opencircle">
+
+     <listitem>
+      <simpara>
+       xmax must be different from zero because a value of zero
+       indicates that the row version is still valid.
+      </simpara>
+     </listitem>
+
+     <listitem>
+      <simpara>
+       xmax must contain an xid which is older than the oldest xid of all
+       currently running transactions (min(pg_stat_activity.backend_xmin)).
+       This criterion guarantees that no existing or upcomming transaction
+       will have read or write access this row version.
+      </simpara>
+     </listitem>
+
+     <listitem>
+      <simpara>
+       The transaction of xmax must be commited. If it was rollback-ed,
+       this row version is treated as valid.
+      </simpara>
+     </listitem>
+
+     <listitem>
+      <simpara>
+       If there is the situation that the row version is part of
+       multiple transactions, special care and some more actions
+       must be taken, see: <xref linkend="vacuum-for-multixact-wraparound"/>.
+      </simpara>
+     </listitem>
+
+    </itemizedlist>
+
+    <para>
+     After the vacuum operation detects a superflous row version, it
+     marks its space as free for future use of writing
+     actions. Only in rare situations (or in the case of VACUUM FULL)
+     this space is released to the operating system. In most cases
+     it keeps occupied by PostgreSQL and will be used by future
+     INSERT or UPDATE commands concerning this or a completely
+     different row.
+    </para>
+
+    <para>
+     Which actions start the elimination of bloat?
+
+    <itemizedlist spacing="compact" mark="opencircle">
+
+      <listitem>
+       <simpara>
+        When a client issues the SQL command VACUUM in its default format,
+        i.e. without any option. To boost performance, in this and the
+        next case VACUUM does not read and act on all pages of the heap.
+        The Visibility Map, which is very compact and therefore has a small
+        size, contains information about pages, where bloat-candidates might
+        be found. Only such pages are processed.
+       </simpara>
+      </listitem>
+
+      <listitem>
+       <simpara>
+        When a client issues the SQL command VACUUM with the option FREEZE.
+       (In this case it undertakes much more actions, see
+       <xref linkend="tutorial-freeze"/>).
+       </simpara>
+      </listitem>
+
+      <listitem>
+       <simpara>
+        When a client issues the SQL command VACUUM with the option FULL.
+        Also in this mode the bloat disappears, but the used strategy
+        is very different: In this case the complete table is copied
+        to a different file skipping all outdated row versions. This
+        leads to a significant reduction of used disc space because
+        the new file contains only the actual data and the old file
+        is deleted.
+       </simpara>
+      </listitem>
+
+      <listitem>
+       <simpara>
+        When an AUTOVACUUM process acts. For optimization
+        purposes he considers the Visiblility Map in the same way as
+        VACUUM. Additionally, he ignores tables with few modifications,
+        see <xref linkend="guc-autovacuum-vacuum-threshold"/>
+        which defaults to 50 rows and
+        <xref linkend="guc-autovacuum-vacuum-scale-factor"/>
+        which defaults to 20%.
+       </simpara>
+      </listitem>
+
+     </itemizedlist>
+    </para>
+
+    <para>
+     This logic only applies to row versions of the heap. Index entries
+     don't use xmin/xmax. Nevertheless such index entries, which would
+     lead to outdated row versions, are released accordingly.
+     (??? more explanations ???)
+    </para>
+
+    <para>
+     The above descriptions omit the fact that xids on a real computer
+     have a limited size. They count up in the same way as sequences and after
+     a certain number of new transactions they are forced to restart
+     from the beginning, which is called <firstterm>wraparound</firstterm>.
+     Therefore the terms 'old transaction' / 'young transaction' does
+     not always correlate with low / hight values of xids. Near to the
+     wraparound point there are cases where xmin has a highter value
+     than xmax, although their meaning is said to be older than xmax.
+    </para>
+
+    <figure id="tutorial-wraparound-figure">
+     <title>Cyclic usage of XIDs</title>
+     <mediaobject>
+      <imageobject role="html">
+       <!-- attribute 'width=..px' is necessary to keep font-size of SVG text
+            in correlation with font-size of surrounding HTML  -->
+       <imagedata fileref="images/wraparound-raw.svg" format="SVG" width="850px" />
+      </imageobject>
+      <imageobject role="fo">
+       <!-- For PDF attribute 'width=100%' is necessary to keep complete SVG visible
+            on the page, which has a fixed width. Font sizes will be adopted.  -->
+       <imagedata fileref="images/wraparound-raw.svg" format="SVG" width="100%" />
+      </imageobject>
+     </mediaobject>
+    </figure>
+
+   </sect2>
+
+   <sect2 id="tutorial-freeze">
+    <title>Freeze Row Versions</title>
+
+    <para>
+     The use of a limited range of IDs for transactions leads
+     to the necessity to restart the sequence sooner or later.
+     This does not only have the rare consequence previously
+     described that sometimes xmin is huger than xmax. The far
+     more important problem is, that whenever the system has
+     to evaluate a WHERE condition, it must decide which row
+     versions are valid (visible) from the perspective of the
+     transaction of this query. If a wraparound couldn't happen,
+     this decision would be relative easy: the xid
+     must be between xmin and xmax, and the corresponding
+     transactions of xmin and xmax must be commited. However,
+     PostgeSQL has to consider the possiblity of wraparounds.
+     Therefore the decision becomes more complex. The general
+     idea of the solution is, to use the 'between xmin and xmax'
+     comparision only during the youngest period of the row
+     versions livetime and afterwards replace it with a
+    'valid forever' flag in its header.
+    </para>
+
+    <itemizedlist spacing="compact" mark="opencircle">
+
+     <listitem>
+      <simpara>
+       In a first step, PostgreSQL divides the complete range of
+       possible xids into two halfs with the two splitt-points
+       'txid_current' and 'txid_current + 2^31'. The half behind
+       'txid_current' is considered to represent xids of the
+       'past' and the half ahead of 'txid_current' those of the
+       'future'. Those of the 'past' are valid (visible) and those
+       of the 'future' not.
+      </simpara>
+     </listitem>
+
+     <listitem>
+      <simpara>
+       Over time the two splitt-points move forward. When
+       'txid_current + 2^31' would reach a row version with
+       xmin equal to that value, it would immediately jump
+       from 'past' to 'future' and would be no longer visible!
+      </simpara>
+     </listitem>
+
+     <listitem>
+      <simpara>
+       To avoid this unacceptable extinction of data the vacuum
+       operation <firstterm>freeze</firstterm> clears the situation
+       long before the splitt-point is reached. It sets a flag
+       in the header of the row version, which eliminates
+       completely the future use of xmin/xmax and indicates
+       that the version is valid not only in the 'past'-half
+       but also in the 'future'-half as well as in all comming
+       <glossterm linkend="glossary-epoch">epochs</glossterm>.
+      </simpara>
+     </listitem>
+    </itemizedlist>
+
+    <para>
+     Which row versions can be frozen by the vacuum operation?
+     Again, serveral criterias must be checked and all must be met.
+
+     <itemizedlist spacing="compact" mark="opencircle">
+
+      <listitem>
+       <simpara>
+        xmax must be zero because only non-deleted rows can be
+        visible 'forever'.
+       </simpara>
+      </listitem>
+
+      <listitem>
+       <simpara>
+        xmin must be older than all currently existing transactions.
+        This guarantees that no existing transaction can modify or
+        delete the version.
+       </simpara>
+      </listitem>
+
+      <listitem>
+       <simpara>
+        The transaction of xmin must be commited.
+       </simpara>
+      </listitem>
+     </itemizedlist>
+    </para>
+
+    <para>
+     At what point in time the freeze operation will take place?
+
+     <itemizedlist spacing="compact" mark="opencircle">
+      <listitem>
+       <simpara>
+        When a client issues the SQL command VACUUM with its
+        FREEZE option. In this case all such pages are
+        processed that are marked in the Visibility Map
+        to potentially have unfrozen rows.
+       </simpara>
+      </listitem>
+
+      <listitem>
+       <simpara>
+        When a client issues the SQL command VACUUM without any
+        option, but finds that there are xids older than
+        <xref linkend="guc-vacuum-freeze-table-age"/>
+        (default: 150 million) minus
+        <xref linkend="guc-vacuum-freeze-min-age"/>
+        (default: 50 million).
+        As before, all such pages are processed that are
+        marked in the Visibility Map to potentially have unfrozen
+        rows.
+       </simpara>
+      </listitem>
+
+      <listitem>
+       <simpara>
+        When an AUTOVACUUM process runs. Such a process acts
+        in one of two modes:
+       </simpara>
+
+       <itemizedlist spacing="compact" mark="opencircle">
+        <listitem>
+         <simpara>
+          In the <emphasis>normal mode</emphasis> he skips
+          pages with row versions that are younger than
+          <xref linkend="guc-vacuum-freeze-min-age"/>
+          (default: 50 million) and works only on pages where
+          all xids are older. The skipping of jung xids prevents
+          work on such pages, which are likely to be changed
+          by one of the future SQL commands.
+         </simpara>
+        </listitem>
+
+        <listitem>
+         <simpara>
+          The process switches
+          to an <emphasis>aggressive mode</emphasis>, if he recognize
+          that for the processed table their oldest xid exceeds
+          <xref linkend="guc-autovacuum-freeze-max-age"/>
+          (default: 200 million). The value of the oldest unfrozen
+          xid is stored per table in <emphasis>pg_class.relfrozenxid</emphasis>.
+          In this <emphasis>aggressive mode</emphasis> mode AUTOVACUUM
+          processes all such pages of the selected table that are marked
+          in the Visibility Map to potentially have bloat or unfrozen rows.
+         </simpara>
+        </listitem>
+
+       </itemizedlist>
+      </listitem>
+     </itemizedlist>
+    </para>
+
+    <para>
+     In the first two cases and with autovacuum in
+     <emphasis>aggressive mode</emphasis>, the system knowns
+     to which value the oldest unfrozen xid has moved forward and
+     logs the value in <emphasis>pg_class.relfrozenxid</emphasis>.
+     The distance between this value and the 'txid_current' split
+     point becomes smaller and the distance to 'txid_current + 2^31'
+     larger than before.
+    </para>
+
+    <figure id="tutorial-freeze-figure">
+     <title>Freeze</title>
+     <mediaobject>
+      <imageobject role="html">
+       <!-- attribute 'width=..px' is necessary to keep font-size of SVG text
+            in correlation with font-size of surrounding HTML  -->
+       <imagedata fileref="images/freeze-raw.svg" format="SVG" width="850px" />
+      </imageobject>
+      <imageobject role="fo">
+       <!-- For PDF attribute 'width=100%' is necessary to keep complete SVG visible
+            on the page, which has a fixed width. Font sizes will be adopted.  -->
+       <imagedata fileref="images/freeze-raw.svg" format="SVG" width="100%" />
+      </imageobject>
+     </mediaobject>
+    </figure>
+
+   </sect2>
+
+   <sect2>
+    <title>Protection against Wraparound Failure</title>
+
+    <para>
+     The AUTOVACUUM processes are initiated by the constantly
+     running <firstterm>autovacuum daemon</firstterm>. If the
+     daemon detects that for a table <firstterm>
+     autovacuum_freeze_max_age</firstterm> is exceeded, it starts
+     an AUTOVACUUM process in the <emphasis>aggressive mode</emphasis>
+     (see above) - even if AUTOVACUUM is disabled.
+    </para>
+   </sect2>
+
+   <sect2>
+    <title>Visibility Map and Free Space Map</title>
+
+    <para>
+     The <xref linkend="glossary-visibility-map"/> (VM)
+     contains two flags - stored as
+     two bits - for each page of the heap. If the first bit
+     is set, it indicates that the associated page does not
+     contain any bloat. If the second one is set, it indicates
+     that the page contains only frozen rows.
+    </para>
+
+    <para>
+      Please consider two details. First, usually a page
+      contains many rows, each of them in many versions.
+      However, the flags are associated with the page,
+      not with a row or a row version! The flags are set
+      only under the condition that they are valid for ALL
+      row versions of the page. Second, since there
+      are only two bits per page, the VM is considerably
+      smaller than the heap. Therefore it is buffered
+      in RAM in almost all cases.
+    </para>
+
+    <para>
+     The setting of the flags is silently done by VACUUM
+     and AUTOVACUUM during their bloat and freeze operations.
+     This is done to accelerate future vacuum actions,
+     regular accesses to heap pages, and some accesses to
+     the index. The flags are cleared with every data-modifying
+     operation on any row version of the page.
+    </para>
+
+    <para>
+     The <xref linkend="glossary-free-space-map"/> (FSM)
+     tracks the amount of free space per page. It is
+     organized as a highly condensed b-tree of (rounded) sizes.
+     As long as VACUUM or AUTOVACUUM change the free space
+     on any processed page, they log the new values in
+     the FSM in the same way as all other writing
+     processes.
+    </para>
+
+   </sect2>
+
+   <sect2>
+    <title>Statistics</title>
+
+    <para>
+     Statistic information helps the <link
+     linkend="planner-stats">Query Planner</link> to take optimal
+     decisions for the generation of execution plans. This
+     information can be gathered with the SQL commands ANALYZE
+     or VACUUM ANALYZE. But also autovacuum processes gather
+     such information. Depending on the percentage of changed rows
+     per table <xref linkend="guc-autovacuum-analyze-scale-factor"/>
+     the autovacuum daemon starts autovacuum processes to collect
+     statistics per table. This dynamic invocation of analyze
+     operations allows <productname>PostgreSQL</productname> to
+     adopt queries to changing circumstances.
+    </para>
+
+    <para>
+     For more details about vacuum operations, especially for its
+     numerous parameters, see <xref linkend="routine-vacuuming"/>.
+    </para>
+
+   </sect2>
+  </sect1>
+
+<!-- ToDo
+
+  <sect1 id="tutorial-transactions-mvcc">
+   <title>Transactions</title>
+
+   <para>
+...
+   </para>
+
+  </sect1>
+
+  <sect1 id="tutorial-backup">
+   <title>Backup</title>
+
+   <para>
+...
+   </para>
+
+  </sect1>
+
+  <sect1 id="tutorial-replication">
+   <title>Replication</title>
+
+   <para>
+...
+   </para>
+
+  </sect1>
+-->
+
+ </chapter>
